
// gcc -O3 -march=native brutesrch.c -o brutesrch

#include <inttypes.h>
#include <stdio.h>

int main(int argc, char *argv[]) {
    uint64_t R1, R2, R8;
    uint64_t solution, max;

    // for key part 3
    R2 = 0x8A46A52D;
    solution = 0x204c4c41;

    // for key part 4
    //R2 = 0xdc6c88e1; //0xe1886cdc;
    //solution = 0x37313032;

    R8 = 0;
    max = 0x100000000;
    while( R8 < max ) {
        R1 = R8;

        R1 = (R1 * R1) % R2;
        R1 = (R1 * R1) % R2;
        R1 = (R1 * R1) % R2;
        R1 = (R1 * R1) % R2;
        R1 = (R1 * R1) % R2;
        R1 = (R1 * R1) % R2;
        R1 = (R1 * R1) % R2;
        R1 = (R1 * R1) % R2;

        R1 = (R1 * R8) % R2;
        if( R1 == solution )
            printf(" Found R8 = 0x%lx\n", R8 );
            //break;
        R8 += 1;

        if( (R8 & 0xFFFFFF) == 0) {
            printf(".");
            fflush(stdout);
        }
    }
    if( R8 < max ) {
        printf(" Found R8 = 0x%lx\n", R8 );
    }
    return 0;
}
